<!doctype html>
<!--
    Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 4.3 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="./">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="../module5">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="../module5/timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="../module5/variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="../module5/continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="../module5/urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="../module5/tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="../module5/exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module5/water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="../module5/course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">v6.0</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/v6.0">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 4.3: Synthesis with requirements</h1>
                    <p>
                        In the third module, we discussed the supervisory controller synthesis algorithm.
                        But, it did not yet take user-specified requirements into account.
                        Now, we adapt the algorithm to also consider such requirements.
                    </p>
                    <p>
                        The difference between plant and requirement automata is how they are handled during synthesis.
                        A plant automaton may specify that a certain event is not possible in a certain location.
                        This is taken as a given by the synthesis algorithm.
                        A requirement automaton may also limit certain events in certain locations.
                        However, the effect of doing so differs between controllable and uncontrollable events.
                        A supervisor may only disable controllable events, but not uncontrollable ones that are possible in the plant.
                        Hence, if a requirement automaton disables a controllable event, the supervisor will simply take this into account as a restriction.
                        But, if a requirement automaton disables an uncontrollable event that is possible in the plant, then synthesis must prevent getting into that state, to ensure the controllability guarantee of synthesis.
                    </p>

                    <h2>Dealing with requirements during synthesis</h2>
                    <p>
                        State requirement invariants are taken into account during synthesis by marking any states that do not adhere to the requirement as bad states.
                        The steps of the synthesis algorithm will then ensure these bad states can't be reached, regardless of whether they could be reached in the plant through controllable or uncontrollable events.
                    </p>
                    <p>
                        State/event exclusion requirement invariants for controllable events can be taken into account by simply disabling the events in the relevant states.
                        That is, for a <code><strong>disables</strong></code> requirement, the states that satisfy the condition, and for a <code><strong>needs</strong></code> requirement, the states that don't satisfy the condition.
                        State/event exclusion requirement invariants for controllable events can be handled in a similar way, but additionally, the source states of these transitions must be marked as bad states, to ensure that the controllability guarantee still holds.
                    </p>
                    <p>
                        To deal with a requirement automaton during synthesis, it is first converted to a plant automaton and some state/event exclusion requirements.
                        That is, the requirement automata is rebranded as a plant automaton.
                        And all restrictions are moved to state/event exclusion requirements.
                        The rebranded requirement then by itself is a non-restrictive plant automaton, that does not prevent any behavior.
                        As an example, consider again the <a href="requirement-automata-and-invariants.html#requirement-order">railway crossing example</a> from earlier in this module, with the following state space:
                    </p>
                    <img src="images/railway-plant-statespace.png">
                    <p>
                        We defined the following requirement automaton, to ensure the correct order of events in the system:
                    </p>
                    <img src="images/railway-requirement.png">
                    <p>
                        If we plantify this requirement automaton, we get the following plant automaton:
                    </p>
                    <img src="images/railway-requirement-plantified.png" id="railway-requirement-plantified">
                    <p>
                        Note how the events that are disabled by the requirement are re-added as self-loops, to ensure they are no longer blocked by this plant automaton.
                    </p>
                    <p>
                        The following state/event exclusion requirement invariants are then added, to replace the restrictions of the original requirement automaton:
                    </p>
                    <ul>
                        <li><code>OffOpen <strong>disables</strong> close</code></li>
                        <li><code>OnOpen <strong>disables</strong> turn_off</code></li>
                        <li><code>OnClosed <strong>disables</strong> open</code></li>
                        <li><code>OffClosed <strong>disables</strong> turn_on</code></li>
                    </ul>
                    <p>
                        The plantified requirement automaton is then taking into account during synthesis like any plant automaton.
                        And the newly added state/event exclusion requirement invariants are taken into account like any state/event exclusion requirement invariant.
                    </p>
                    <p>
                        In general, plantification can be slightly more complex.
                        If in a location of a requirement automaton, an edge for an event has a guard, the self loop gets the negated guard.
                        For instance, if an edge has guard <code>x &gt; 0</code>, then the self loop would get guard <code>not (x &gt; 0)</code>, which is the same as <code>x <= 0</code>.
                        And if there are multiple outgoing edges for the same event, the self loop gets a guard that indicates that none of the guards of the original edges is satisfied.
                        That is, the self loop gets a guard that is only enabled if none of the other edges is enabled.
                        For instance, if there are two edges with guards <code>x &gt; 0</code> and <code>x &lt; 0</code>, the self loop would get guard <code>(not x &gt; 0) and (not x &lt; 0)</code>, which is the same as <code>x = 0</code>.
                        An added self loop has no updates, and therefore just ensures that the event is not disabled by the plantified requirement automaton.
                    </p>

                    <h2>The updated synthesis algorithm</h2>
                    <p>
                        The synthesis algorithm still takes the uncontrolled plant as input, but now additionally gets requirements as well.
                        It then performs the following steps:
                    </p>
                    <ol>
                        <li>
                            Plantify the requirement automata to plant automata and state/event exclusion requirement invariants.
                        </li>
                        <li>
                            Determine all states where state requirement invariants don't hold.
                            Mark them as bad states and remove them.
                        </li>
                        <li>
                            Disable all transitions for controllable events in states where they violate a state/event exclusion requirement invariant.
                        </li>
                        <li>
                            Disable all transitions for uncontrollable events in states where they violate a state/event exclusion requirement invariant.
                            Additionally, mark their source states as bad states and remove them.
                        </li>
                    </ol>
                    <ol start="5">
                        <li>
                            Determine all blocking states.
                            Mark them as bad states and remove them.
                        </li>
                        <li>
                            Determine all non-controllable states, the states from which an uncontrollable-event transition is possible to a bad state.
                            Mark them as bad states and remove them.
                        </li>
                        <li>
                            Optionally, determine all unreachable states.
                            Mark them as bad states and remove them.
                        </li>
                        <li>
                            Disable all transitions for controllable events in states where they lead to a bad state.
                        </li>
                        <li>
                            If any of the previous steps led to removing any states or disabling any transitions, repeat the steps again, starting from step 5.
                        </li>
                    </ol>
                    <p>
                        The first four steps are preparation steps that are only performed once.
                        The remaining steps are repeated as often as is necessary, until no more behavior is removed.
                    </p>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'single-choice',
                                question: "How are state requirement invariants taken into account during synthesis?",
                                answers: [
                                    "They are converted to state/event exclusion requirement invariants and taken into accounts as such.",
                                    "They are converted to requirement automata and taken into account as such.",
                                    "They are taken into account by removing transitions and marking additional bad states.",
                                    "They are taken into account by marking additional bad states.",
                                ],
                                correctAnswer: '4'
                            },
                            {
                                type: 'single-choice',
                                question: "How are state/event exclusion requirement invariants taken into account during synthesis?",
                                answers: [
                                    "They are converted to state/event exclusion requirement invariants and taken into accounts as such.",
                                    "They are converted to requirement automata and taken into account as such.",
                                    "They are taken into account by removing transitions and marking additional bad states.",
                                    "They are taken into account by marking additional bad states.",
                                ],
                                correctAnswer: '3'
                            },
                            {
                                type: 'single-choice',
                                question: "How are requirement automata taken into account during synthesis?",
                                answers: [
                                    "They are converted to plant automata and state/event exclusion requirement invariants and taken into accounts as such.",
                                    "They are converted to plant automata and state requirement invariants and taken into accounts as such.",
                                    "They are taken into account by removing transitions and marking additional bad states.",
                                    "They are taken into account by marking additional bad states.",
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'single-choice',
                                question: "Why would happen if physical relations between a sensor an actuator are accidentally modeled as a requirement automaton rather than a plant automaton?",
                                answers: [
                                    "That is fine, as it is up to the modeler to decide whether it is a plant for a requirement.",
                                    "That is fine, as synthesis will correct for this and ensure the controlled system still works as desired.",
                                    "This would lead to an undesired controlled system, as the requirement then disables uncontrollable events.",
                                ],
                                correctAnswer: '3'
                            }
                        ]
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="requirement-automata-and-invariants.html">Go back to Module 4.2</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="modeling-for-synthesis.html">Proceed to Module 4.4</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2024 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
